/*
 *	c2html (Kdov jmno: fwc2hcfl - Free Woq's C To HTML Convertor For Linux)
 *	Oznakuje zdrojov kdy jazyka C/C++ pomoc tag HTML. Vhodn pro vpisy zdrojovch kd ve lncch na webovch strnkch.
 *
 *	Michal Turek - Woq, 30.1.2004
 *
 *	woq@email.cz
 *	http://woq.nipax.cz/
 *	http://nehe.opengl.cz/
 *
 *	Program i kd je voln iiteln podle licence GNU GPL (http://www.gnu.cz/), pouit absolutn bez zruky.
 *
 */

#include <stdio.h>
#include <string.h>

// "Obyejn" Cko nezn datov typ bool
#define bool int
#define false 0
#define true 1

// Poet znak novho dku (Linux - 1, Windows - 2)
#define NL 1

// #define DEBUG_VYPISY

void Konverze(char* pData, long velikost_souboru, FILE* fw)// Funkce pro konverzi (jednodu je napsat ji znovu ne se snait pochopit a upravit)
{
	unsigned long i;// Pro hlavn cyklus

	bool komentar = false;// Flag komente (//)
	bool viceradkovy_komentar = false;// Flag vcedkovho komente (/* */)
	unsigned int zanoreni = 0;// Berou se v vahu pouze { a }
	int pom = 0;// Pomocn

	fprintf(fw, "<p class=\"src0\">");// vodn tag

	for(i = 0; i < velikost_souboru; i++)// Vechny znaky v bufferu
	{
		if(pData[i] == '\t')// Tabultor
		{
			continue;// Peskoit (Warning: spojuje slova, kdy jsou kvli zarovnn oddlen tabultorem msto mezerou)
		}

		if(pData[i] == 13)// '\n' jsou v MS(R) Windows(R)TM dva znaky 13 a 10 ('\r' a '\n') - hzelo to zmaty
		{
			continue;// Peskoit
		}

		if(pData[i] == '\n')// Nov dek
		{
			if(zanoreni > 0)
			{
				pom = 0;

				while(++pom != 10)// Hled uzavrac zvorku (peskakuje taby na za. dku). Po pl roce: "To funguje?!"
				{
					if(pData[i + pom] == '}')
					{
						zanoreni--;
						break;
					}
				}
			}

			if(komentar)
			{
				if(pData[i + NL] == '\n')// Dva entry za sebou
				{
					fprintf(fw, "</span></p>\n<p>");
				}
				else
				{
					fprintf(fw, "</span></p>\n<p class=\"src%d\">", zanoreni);// \n
				}

				komentar = false;
			}
			else if(viceradkovy_komentar)
			{
				if(pData[i + NL] == '\n')// Dva entry za sebou
				{
					fprintf(fw, "</span></p>\n<p>");
				}
				else
				{
					fprintf(fw, "</span></p>\n<p class=\"src%d\"><span class=\"kom\">", zanoreni);// \n
				}
			}
			else if(pData[i + NL] == '\n')// Dva entry za sebou
			{
				fprintf(fw, "</p>\n<p>");// \n
			}
			else
			{
				fprintf(fw, "</p>\n<p class=\"src%d\">", zanoreni);// \n
			}
		}
		else if(pData[i] == '<')
		{
			fprintf(fw, "&lt;");// <
		}
		else if(pData[i] == '>')
		{
			fprintf(fw, "&gt;");// >
		}
		else if(pData[i] == '&')
		{
			fprintf(fw, "&amp;");// &
		}
		else if(pData[i] == '\"')
		{
			fprintf(fw, "&quot;");// "
		}
		else if(pData[i] == '{')
		{
			zanoreni++;//Zvt zanoen
			pom = 0;

			while(pData[i + pom] != '\n')
			{
				pom++;

				if(pData[i + pom] == '}')
				{
					zanoreni--;// Zmen zanoen
					break;
				}
			}

			fprintf(fw, "{");// {
		}
		else if(pData[i] == '}')
		{
			// zanoreni -= 30;

			fprintf(fw, "}");// }
		}
		else if(pData[i] == '/')// Komente
		{
			if(pData[i + 1] == '/')// jednodkov koment
			{
				if(!komentar && !viceradkovy_komentar)
				{
					fprintf(fw, "<span class=\"kom\">");
				}

				komentar = true;
			}
			else if(pData[i + 1] == '*')// Zatek vcedkovho komente
			{
				if(!viceradkovy_komentar)
				{
					viceradkovy_komentar = true;

					if(!komentar)
					{
						fprintf(fw, "<span class=\"kom\">");
					}

					komentar = false;
				}
			}

			fprintf(fw, "/");// /

			if(i > 0)// Kvli [i - 1] na nsledujcm dku (hzelo to errory)
			{
				if(pData[i - 1] == '*')// Konec vcedkovho komente
				{
					if(viceradkovy_komentar)
					{
						viceradkovy_komentar = false;
						komentar = false;

						fprintf(fw, "</span>");
					}
				}
			}
		}
		else// dn speciln znak
		{
			fputc(pData[i], fw);// Obyejn vloen do souboru
		}
	}

	fprintf(fw, "</p>");// Koncov tag
}

int main(int argc, char** argv)
{
#ifdef DEBUG_VYPISY
	printf("DEBUG: Poet parametr pkazovho dku: %d\n", argc);
#endif

	if(argc < 2)
	{
		fprintf(stderr, "ERROR: Program se mus volat s parametrem, kter oznauje cestu ke vstupnmu (.c) souboru.\n");
		fprintf(stderr, "       Jmno vstupnho (.html) souboru se vygeneruje automaticky pidnm ppony .html k nzvu.\n");
		return 1;
	}

	int i;

	for(i = 1; i < argc; i++)// Vechny parametry pkazovho dku; aby se program mohl volat s vce parametry nebo "c2html *.c"
	{
		///// Generovn jmna vstupnho souboru /////

#ifdef DEBUG_VYPISY
		printf("DEBUG: Dlka etzce se jmnem vstupnho souboru: %d znak\n", strlen(argv[i]));
		printf("DEBUG: Jmno vstupnho souboru: '%s'\n", argv[i]);
#endif

		char filename_out[strlen(argv[i]) + 6];// Alokace pamti pro etzec (jmno + '.html' + '\0')

		strcpy(filename_out, argv[i]);// Koprovn
		strcat(filename_out, ".html");// Spojen

#ifdef DEBUG_VYPISY
		printf("DEBUG: Jmno vstupnho souboru: '%s'\n", filename_out);
#endif

		///// Zjitn velikosti vstupnho souboru /////

		FILE *fr = NULL;// Handle

		if((fr = fopen(argv[i], "rb")) == NULL)// Pro ten v BIN mdu
		{
			fprintf(stderr, "ERROR: Vstupn soubor '%s' nelze otevt, bu neexituje, nebo nemte dostaten prva.\n", argv[i]);
			return 3;
		}

		fseek(fr, 0L, SEEK_END);// Pesun na konec souboru (respektive o nula byt od konce)
		long velikost_souboru = ftell(fr);// Pozice v souboru

		fclose(fr);
		fr = NULL;

#ifdef DEBUG_VYPISY
		printf("DEBUG: Velikost vstupnho souboru: %ld B\n", velikost_souboru);
#endif

		///// Naten vstupnho souboru do pamti /////

		if((fr = fopen(argv[i], "r")) == NULL)// Oteven pro ten
		{
			fprintf(stderr, "ERROR: Vstupn soubor '%s' nelze otevt, bu neexituje, nebo nemte dostaten prva.\n", argv[i]);
			return 4;
		}

		char obsah_souboru[velikost_souboru + 1];// Alokace pamti pro data ze souboru
		int j;// Pro cyklus

		for(j = 0; j < velikost_souboru; j++)// Naten do pamti
		{
			obsah_souboru[j] = getc(fr);
		}

		obsah_souboru[j] = '\0';// Ukonovac znak

		fclose(fr);
		fr = NULL;

		///// "Konverze" C na HTML /////

		FILE *fw = NULL;

		if((fw = fopen(filename_out, "w")) == NULL)
		{
			fprintf(stderr, "ERROR: Vstupn soubor '%s' nelze otevt.\n", filename_out);
			return 5;
		}

		Konverze(obsah_souboru, velikost_souboru, fw);

		fclose(fw);
		fw = NULL;
	}

	return 0;// OK
}
